Name: coreutils
Version: 5.0
Release: alt3

Summary: The GNU versions of common management utilities
License: GPL
Group: System/Base
Url: ftp://ftp.gnu.org/gnu/%name
Packager: Coreutils Development Team <coreutils@packages.altlinux.org>

Source: %url/%name-%version.tar.bz2

# sources from fileutils
Source101: color_ls.sh
Source102: color_ls.csh

# sources from sh-utils
Source200: exit.S
Source201: getuseruid.c
Source202: realpath.c
Source203: runas.c
Source204: runbg.c
Source205: usleep.c
Source206: runas.1
Source207: usleep.1

# ALT patches, candidates for upstream version
# and CVS backports.
Patch1: coreutils-5.0-cvs-ftw.patch

# ALT specific patches.
Patch11: coreutils-4.5.7-alt-texinfo.patch
Patch12: coreutils-4.5.5-alt-mksock.patch
Patch13: coreutils-4.5.3-alt-dircolors.patch
Patch14: coreutils-4.5.11-alt-without-hostname-su-uptime.patch
Patch15: coreutils-4.5.3-alt-ls_dir_vdir.patch

# patches from fileutils.
Patch101: coreutils-4.5.3-rh-df_spacedir.patch
Patch102: fileutils-4.1.11-rh-owl-install-C.patch
Patch103: coreutils-4.5.3-rh-install_strip.patch
Patch104: coreutils-4.5.3-rh-owl-alt-ls_dumbterm.patch
Patch105: coreutils-4.5.3-rh-CLOCK_REALTIME.patch
Patch106: coreutils-4.5.3-alt-owl-chown.patch 
Patch107: fileutils-4.1.11-owl-fixes.patch
Patch108: fileutils-4.1.11-rh-owl-ls_default_time_style.patch

# patches from textutils.
Patch201: textutils-2.0.17-rh-mem.patch

# patches from sh-utils.
Patch301: coreutils-4.5.3-rh-utmp.patch
Patch302: coreutils-4.5.3-rh-man-date.patch

PreReq: %_sbindir/install_info, %_sbindir/uninstall_info

Provides: /bin/du /bin/install /bin/mkfifo /bin/readlink
Provides: /bin/cat /bin/cut /bin/head /bin/sort /bin/tail /bin/wc
Provides: %_bindir/mksock %_bindir/realpath

Provides: stat = %version, fileutils = %version, textutils = %version, sh-utils = %version
Obsoletes: stat, fileutils, textutils, sh-utils
Conflicts: man-pages < 0:1.52-alt2, initscripts < 5.49-ipl41mdk, rpm-build < 4.0.4-alt7

BuildPreReq: texinfo >= 0:4.3

# Automatically added by buildreq on Tue Jun 03 2003
BuildRequires: glibc-devel-static help2man libtinfo-devel

%package -n rm-static
Summary: Static version of the GNU rm
Group: File tools
Requires: %name = %version-%release

%description
These are the GNU core utilities.  This package is the union of
the GNU fileutils, sh-utils, and textutils packages.

These tools are the GNU versions of common useful and popular
file and text utilities which are used for:
+ file management
+ shell scripting
+ modifying text file

Most of these programs have significant advantages over their Unix
counterparts, such as greater speed, additional options, and fewer
arbitrary limits.

%description -n rm-static
This package contains statically linked version of the GNU rm program.

%prep
%setup -q

# ALT patches, candidates for upstream version
# and CVS backports.
%patch1 -p0

# ALT specific patches.
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1

# patches from fileutils.
%patch101 -p1
%patch102 -p1
%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1

# patches from textutils.
%patch201 -p1

# patches from sh-utils.
%patch301 -p1
%patch302 -p1

# Get rid of hostname, su and uptime.
%__rm -fv {src,man}/{hostname,su,uptime}.*

# begin HACK
%__subst 's/dist_man_MANS/man_MANS/g' man/Makefile.am
# end HACK

# Fix docs: it should say /var/run/[uw]tmp not /etc/[uw]tmp
%__grep -Zl /etc/[uw]tmp doc/* man/* |
	xargs -r0 %__subst -p 's,/etc/utmp,/var/run/utmp,g;s,/etc/wtmp,/var/log/wtmp,g'

%__install -p -m755 /usr/bin/help2man man/
%__rm -f doc/*.info* man/*.1

%build
aclocal -I m4
autoheader
automake
autoconf

# hack to disable uptime build.
export gnulib_cv_have_boot_time=no

%configure --exec-prefix=/
%make_build

# Build rm.static
pushd src
	mv rm rm.dynamic
	make rm LDFLAGS=-static
	mv rm rm.static
	mv rm.dynamic rm
popd
%{?!__buildreqs:%{?!_without_check:%{?!_disable_check:%make_build check}}}

# Build assembler version of true and false.
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=0 -o true
gcc -nostartfiles -nodefaultlibs -nostdlib "$RPM_SOURCE_DIR"/exit.S -DSTATUS=1 -o false

# Build additional utilities.
for n in getuseruid realpath runas runbg usleep; do
	gcc $RPM_OPT_FLAGS "$RPM_SOURCE_DIR/$n.c" -o $n
done

%install
%makeinstall
%__install -pD -m644 src/dircolors.hin "$RPM_BUILD_ROOT%_sysconfdir/DIR_COLORS"

pushd "$RPM_BUILD_ROOT"
	%__mkdir_p bin
	
#replace fileutils
        for n in \
	    chgrp chmod chown cp dd df du install link ln ls \
	    mkdir mkfifo mknod mv readlink rm rmdir sync touch unlink \
	; do
		%__mv "$RPM_BUILD_ROOT%_bindir/$n" "$RPM_BUILD_ROOT/bin/"
	done

	# dir and vdir now symlinks to ls.
	%__ln_s -nf ../../bin/ls "$RPM_BUILD_ROOT%_bindir/dir"
	%__ln_s -nf ../../bin/ls "$RPM_BUILD_ROOT%_bindir/vdir"

#replace textutils
	for n in cat cut head sort tail wc; do
		%__mv "$RPM_BUILD_ROOT%_bindir/$n" "$RPM_BUILD_ROOT/bin/"
		%__ln_s "../../bin/$n" "$RPM_BUILD_ROOT%_bindir/"
	done

#replace sh-utils
	for i in basename date echo false nice pwd sleep stty true uname; do
		%__mv .%_bindir/$i ./bin/
	done

	%__mkdir_p .%_sbindir
	%__mv .%_bindir/chroot .%_sbindir/

	%__ln_s -nf test .%_bindir/[

#compatibility symlinks
	for f in du install mkfifo; do
		%__ln_s ../../bin/$f .%_bindir/
	done

	%__mkdir_p .%_sysconfdir/profile.d
	%__install -p -m755 %SOURCE101 %SOURCE102 .%_sysconfdir/profile.d/
	%__ln_s ../../bin/install .%_bindir/ginstall
popd

# Install rm.static
%__install -p -m755 src/rm.static "$RPM_BUILD_ROOT%_bindir/"

# Install assembler versions of true and false.
%__install -p -m755 true false "$RPM_BUILD_ROOT/bin/"

# Install additional utilities and its manpages.
%__install -p -m755 getuseruid runas usleep $RPM_BUILD_ROOT/bin/
%__install -p -m755 realpath runbg $RPM_BUILD_ROOT%_bindir/
%__install -p -m644 $RPM_SOURCE_DIR/{runas,usleep}.1 $RPM_BUILD_ROOT%_man1dir/

# Remove some extra programs.
%__rm -rf $RPM_BUILD_ROOT%_bindir/kill

%find_lang %name

%pre
# Remove info pages from fileutils, textutils and sh-utils.
for f in %_infodir/{fileutils,textutils,sh-utils}.info*; do
	[ -f "$f" ] || continue
	RPM_INSTALL_ARG1=0 %_sbindir/uninstall_info "$f" ||:
done

%post
%install_info %name.info

%preun
%uninstall_info %name.info

%files -f %name.lang
%config(noreplace) %_sysconfdir/DIR_COLORS
%config(noreplace) %_sysconfdir/profile.d/*
/bin/*
%_bindir/*
%exclude %_bindir/rm.static
%_sbindir/*
%_mandir/man?/*
%_infodir/*.info*
%doc ABOUT-NLS AUTHORS ChangeLog NEWS README THANKS TODO

%files -n rm-static
%_bindir/rm.static

%changelog
* Tue Jun 03 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt3
- Fixed file descriptor leakage in du (Jim Meyering).
- Build statically linked version of the GNU rm program
  and package it into rm-static subpackage.

* Fri May 02 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt2
- Regenerated manpages with help2man-1.29-alt2.
- Ported %%pre script to new uninstall_info.

* Sun Apr 06 2003 Dmitry V. Levin <ldv@altlinux.org> 5.0-alt1
- Updated to 5.0

* Mon Mar 31 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.12-alt1
- Updated to 4.5.12

* Thu Mar 20 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.11-alt1
- Updated to 4.5.11

* Fri Mar 14 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.10-alt1
- Updated to 4.5.10

* Wed Mar 05 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.9-alt1
- Updated to 4.5.9

* Sat Feb 22 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.8-alt1
- Updated to 4.5.8

* Mon Feb 10 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.7-alt1
- Updated to 4.5.7
- Updated patches:
  + alt-texinfo

* Thu Feb 06 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.6-alt1
- Updated to 4.5.6
- Merged upstream patches:
  + alt-who_xmalloc_fix
- Updated patches:
  + alt-texinfo

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.5-alt1
- Updated to 4.5.5
- Merged upstream patches:
  + alt-xalloc
  + alt-xgetcwd
  + alt-canonicalize
  + alt-readlink
  + alt-owl-rh-ls_restore_color
- New patches:
  + alt-xalloc
- Updated patches:
  + alt-mksock
  + alt-without-hostname-su-uptime

* Tue Feb 04 2003 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt3
- who: fixed memory allocation arithmetic (#0002149).

* Sun Dec 01 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt2
- Removed automake patch (no longer needed with automake >= 1.7).
- Minor code cleanups (xalloc and xgetcwd).
- Added canonicalize_file_name implementation to libfetish;
  affects non-glibc platforms.
- Turned dir and vdir into symlinks to ls (#0001635).
- Updated dircolors.
- Removed obsolete (merged) patches:
  sh-utils-2.0-rh-rfc822
- Removed obsolete (not applied) patches:
  fileutils-4.0.38-alt-cp_deref_always
  fileutils-4.1-alt-cp_force_ignore
- Rediffed patches:
  rh-df_spacedir
  rh-install_strip
  rh-owl-alt-ls_dumbterm
  rh-CLOCK_REALTIME
  alt-owl-chown
- Corrected description.

* Thu Oct 31 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.3-alt1
- Updated to 4.5.3
- Our "ln --target-dir" fix merged upstream.

* Sun Oct 13 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt2
- Minor specfile tweaks.
- Updated buildrequires.

* Tue Oct 08 2002 Dmitry V. Levin <ldv@altlinux.org> 4.5.2-alt1
- Updated to 4.5.2
- Disabled cp_deref_always patch.
- Enabled tests by default.
- Fixed "ln --target-dir" (#0001369).

* Thu Sep 26 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt2
- Ressurected Conflicts.

* Tue Sep 17 2002 Stanislav Ievlev <inger@altlinux.ru> 4.5.1-alt1
- Inital build for ALT. This package is the union of the
  fileutils, sh-utils, and textutils packages.
- Review patches:
  + dropped "rh-stoneage" patch;
  + adopted readlink and mksock patches;
  + disabled "force interactive" patch.
