#include <stdio.h>
#include <errno.h>
#include <error.h>
#include <stdlib.h>
#include <limits.h>
#include <unistd.h>

extern const char *__progname;

void
usage (void)
{
	fprintf (stderr, "usage: %s [microseconds]\n", __progname);
	exit (EXIT_FAILURE);
}

int
main (int ac, const char *av[])
{
	long    delay = 1;

	if (ac < 1 || ac > 2)
		usage ();

	if (ac == 2)
	{
		char   *p = 0;

		delay = strtoul (av[1], &p, 0);
		if (*p || delay < 0 || delay == ULONG_MAX)
		{
			error (EXIT_SUCCESS, EINVAL, "%s", av[1]);
			usage ();
		}
	}

	usleep (delay);
	return EXIT_SUCCESS;
}
